#include <iostream>

template <class T>
class PilhaMin { 

    public:
        void empilha(T elemento) {
            N++;
            elementos[N -1] = elemento;

        }
        T desempilha() {
            if (N > 0) {
                N--;
                return elementos[N];
            }
            else
                return -1;
        }

        T topo() {
            if (N > 0)
                return elementos[N -1];
            else   
                return -1;
        }

        T obterMinimo() {
            T *minimo = &elementos[0];
            for (int i = 1; i < N; i++) {
                if (elementos[i] < *(minimo))
                    minimo = &elementos[i];
            }

            return *(minimo);
        }

    private:
        static const int MAX = 900;
        int N = 0;
        T elementos[MAX];

};

void preencherPilha(PilhaMin<char> &pilha) {

    
    pilha.empilha('b');
    pilha.empilha('c');
    pilha.empilha('d');
    pilha.empilha('e');
    pilha.empilha('f');
    pilha.empilha('g');
    pilha.empilha('h');
    pilha.empilha('i');
    pilha.empilha('j');
    pilha.empilha('k');
    pilha.empilha('l');
    pilha.empilha('m');
    pilha.empilha('a');
    pilha.empilha('1');
    pilha.empilha('n');
    pilha.empilha('o');
    pilha.empilha('p');
    pilha.empilha('q');
    pilha.empilha('r');
    pilha.empilha('s');
    pilha.empilha('t');
    pilha.empilha('u');
    pilha.empilha('v');
    pilha.empilha('w');
    pilha.empilha('x');
    pilha.empilha('y');
    pilha.empilha('z');
}


int main(int argc, char* argv[]) {


    PilhaMin<char> pilha;

    preencherPilha(pilha);

    std::cout << "Mínimo: " << pilha.obterMinimo() << std::endl;

    return 0;
}